// PartNumID.cpp: implementation of the CPartNum class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ChipDefs.h"
#include "PartNumID.h"
#include "FlashInfo.h"
#include "resource.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CPartNumID *psChipData = NULL;

///* Get Flash Info by PID */
//typedef struct
//{
//	unsigned int uProgramMemorySize;
//	unsigned int uDataFlashSize;
//	unsigned int uRAMSize;
//	unsigned int uDataFlashStartAddress;
//	unsigned int uISPFlashSize;
//	unsigned int uPID;
//} FLASH_PID_INFO_BASE_T;
//
///* Get Flash Info by DID */
//typedef struct
//{
//	unsigned int uProgramMemorySize;
//	unsigned int uDataFlashSize;
//	unsigned int uRAMSize;
//	unsigned int uDataFlashStartAddress;
//	unsigned int uDID;
//} FLASH_DID_INFO_BASE_T;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

struct CPartNumID g_PartNumIDs[] =
{
	/* NUC1xx's Part Number */
	{"NUC100LE3AN", 0x00010000, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LE2AN", 0x00010001, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LE1AN", 0x00010002, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LD3AN", 0x00010003, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LD2AN", 0x00010004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LD1AN", 0x00010005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LC3AN", 0x00010006, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LC2AN", 0x00010007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LC1AN", 0x00010008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RE3AN", 0x00010009, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RE2AN", 0x00010010, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RE1AN", 0x00010011, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RD3AN", 0x00010012, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RD2AN", 0x00010013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100SD2AN", 0x00010031, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RD1AN", 0x00010014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RC3AN", 0x00010015, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RC2AN", 0x00010016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RC1AN", 0x00010017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VE3AN", 0x00010018, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VE2AN", 0x00010019, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VE1AN", 0x00010020, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VD3AN", 0x00010021, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VD2AN", 0x00010022, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VD1AN", 0x00010023, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VC3AN", 0x00010024, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VC2AN", 0x00010025, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VC1AN", 0x00010026, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC101LE3AN", 0x00010100, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LE2AN", 0x00010101, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LE1AN", 0x00010102, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LD3AN", 0x00010103, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LD2AN", 0x00010104, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LD1AN", 0x00010105, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LC3AN", 0x00010106, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LC2AN", 0x00010107, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LC1AN", 0x00010108, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RE3AN", 0x00010109, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RE2AN", 0x00010110, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RE1AN", 0x00010111, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RD3AN", 0x00010112, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RD2AN", 0x00010113, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RD1AN", 0x00010114, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RC3AN", 0x00010115, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RC2AN", 0x00010116, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RC1AN", 0x00010117, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VE3AN", 0x00010118, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VE2AN", 0x00010119, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VE1AN", 0x00010120, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VD3AN", 0x00010121, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VD2AN", 0x00010122, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VD1AN", 0x00010123, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VC3AN", 0x00010124, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VC2AN", 0x00010125, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VC1AN", 0x00010126, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC102LE3AN", 0x00010200, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LE2AN", 0x00010201, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LE1AN", 0x00010202, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LD3AN", 0x00010203, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LD2AN", 0x00010204, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LD1AN", 0x00010205, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LC3AN", 0x00010206, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LC2AN", 0x00010207, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LC1AN", 0x00010208, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RE3AN", 0x00010209, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RE2AN", 0x00010210, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RE1AN", 0x00010211, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RD3AN", 0x00010212, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RD2AN", 0x00010213, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RD1AN", 0x00010214, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RC3AN", 0x00010215, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RC2AN", 0x00010216, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RC1AN", 0x00010217, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SE3AN", 0x00010218, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SE2AN", 0x00010219, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SE1AN", 0x00010220, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SD3AN", 0x00010221, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SD2AN", 0x00010222, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SD1AN", 0x00010223, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SC3AN", 0x00010224, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SC2AN", 0x00010225, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SC1AN", 0x00010226, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZE3AN", 0x00010227, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZE2AN", 0x00010228, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZE1AN", 0x00010229, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZD3AN", 0x00010230, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZD2AN", 0x00010231, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZD1AN", 0x00010232, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZC3AN", 0x00010233, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZC2AN", 0x00010234, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZC1AN", 0x00010235, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZB3AN", 0x00010236, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZB2AN", 0x00010237, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZB1AN", 0x00010238, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZA3AN", 0x00010239, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZA2AN", 0x00010240, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZA1AN", 0x00010241, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LB3AN", 0x00010242, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LB2AN", 0x00010243, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LB1AN", 0x00010244, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LA3AN", 0x00010245, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LA2AN", 0x00010246, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LA1AN", 0x00010247, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RB3AN", 0x00010248, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RB2AN", 0x00010249, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RB1AN", 0x00010250, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RA3AN", 0x00010251, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RA2AN", 0x00010252, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RA1AN", 0x00010253, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SB3AN", 0x00010254, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SB2AN", 0x00010255, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SB1AN", 0x00010256, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SA3AN", 0x00010257, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SA2AN", 0x00010258, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SA1AN", 0x00010259, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LA0AN", 0x00010260, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LB0AN", 0x00010261, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LC0AN", 0x00010262, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102LD0AN", 0x00010263, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RA0AN", 0x00010264, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RB0AN", 0x00010265, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RC0AN", 0x00010266, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102RD0AN", 0x00010267, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SA0AN", 0x00010268, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SB0AN", 0x00010269, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SC0AN", 0x00010270, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102SD0AN", 0x00010271, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZA0AN", 0x00010272, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZB0AN", 0x00010273, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZC0AN", 0x00010274, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102ZD0AN", 0x00010275, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YD3AN", 0x00010276, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YD2AN", 0x00010277, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YD1AN", 0x00010278, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YD0AN", 0x00010279, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YC3AN", 0x00010280, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YC2AN", 0x00010281, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YC1AN", 0x00010282, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YC0AN", 0x00010283, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YB3AN", 0x00010284, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YB2AN", 0x00010285, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YB1AN", 0x00010286, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YB0AN", 0x00010287, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YA3AN", 0x00010288, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YA2AN", 0x00010289, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YA1AN", 0x00010290, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC102YA0AN", 0x00010291, IDD_DIALOG_CONFIGURATION_NUC100},

	/* 103 series*/
	{"NUC103SB2AN0", 0x00010300, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SB2AN1", 0x00010301, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SB3AN0", 0x00010302, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SB4AN0", 0x00010303, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC2AN0", 0x00010304, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC2AN1", 0x00010305, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC3AN0", 0x00010306, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC4AN0", 0x00010307, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC2AN2", 0x00010308, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC2AN3", 0x00010309, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC3AN2", 0x00010310, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC4AN2", 0x00010311, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SD2AN0", 0x00010312, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SD2AN1", 0x00010313, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SD3AN0", 0x00010314, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SD4AN0", 0x00010315, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SE2AN0", 0x00010316, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SE2AN1", 0x00010317, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SE3AN0", 0x00010318, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SE4AN0", 0x00010319, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LB2AN0", 0x00010320, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LB2AN1", 0x00010321, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LB3AN0", 0x00010322, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LB4AN0", 0x00010323, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC2AN0", 0x00010324, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC2AN1", 0x00010325, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC3AN0", 0x00010326, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC4AN0", 0x00010327, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC2AN2", 0x00010328, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC2AN3", 0x00010329, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC3AN2", 0x00010330, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC4AN2", 0x00010331, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LD2AN0", 0x00010332, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LD2AN1", 0x00010333, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LD3AN0", 0x00010334, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LD4AN0", 0x00010335, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LE2AN0", 0x00010336, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LE2AN1", 0x00010337, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LE3AN0", 0x00010338, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LE4AN0", 0x00010339, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZB2AN0", 0x00010340, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZB2AN1", 0x00010341, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZB3AN0", 0x00010342, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZB4AN0", 0x00010343, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC2AN0", 0x00010344, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC2AN1", 0x00010345, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC3AN0", 0x00010346, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC4AN0", 0x00010347, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC2AN2", 0x00010348, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC2AN3", 0x00010349, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC3AN2", 0x00010350, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC4AN2", 0x00010351, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZD2AN0", 0x00010352, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZD2AN1", 0x00010353, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZD3AN0", 0x00010354, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZD4AN0", 0x00010355, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZE2AN0", 0x00010356, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZE2AN1", 0x00010357, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZE3AN0", 0x00010358, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZE4AN0", 0x00010359, IDD_DIALOG_CONFIGURATION_NUC103},

	/* 103 series*/
	{"NUC103SB2BN0", 0x10010300, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SB2BN1", 0x10010301, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SB3BN0", 0x10010302, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SB4BN0", 0x10010303, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC2BN0", 0x10010304, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC2BN1", 0x10010305, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC3BN0", 0x10010306, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC4BN0", 0x10010307, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC2BN2", 0x10010308, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC2BN3", 0x10010309, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC3BN2", 0x10010310, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SC4BN2", 0x10010311, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SD2BN0", 0x10010312, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SD2BN1", 0x10010313, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SD3BN0", 0x10010314, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SD4BN0", 0x10010315, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SE2BN0", 0x10010316, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SE2BN1", 0x10010317, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SE3BN0", 0x10010318, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103SE4BN0", 0x10010319, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LB2BN0", 0x10010320, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LB2BN1", 0x10010321, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LB3BN0", 0x10010322, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LB4BN0", 0x10010323, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC2BN0", 0x10010324, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC2BN1", 0x10010325, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC3BN0", 0x10010326, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC4BN0", 0x10010327, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC2BN2", 0x10010328, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC2BN3", 0x10010329, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC3BN2", 0x10010330, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LC4BN2", 0x10010331, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LD2BN0", 0x10010332, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LD2BN1", 0x10010333, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LD3BN0", 0x10010334, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LD4BN0", 0x10010335, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LE2BN0", 0x10010336, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LE2BN1", 0x10010337, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LE3BN0", 0x10010338, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103LE4BN0", 0x10010339, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZB2BN0", 0x10010340, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZB2BN1", 0x10010341, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZB3BN0", 0x10010342, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZB4BN0", 0x10010343, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC2BN0", 0x10010344, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC2BN1", 0x10010345, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC3BN0", 0x10010346, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC4BN0", 0x10010347, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC2BN2", 0x10010348, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC2BN3", 0x10010349, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC3BN2", 0x10010350, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZC4BN2", 0x10010351, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZD2BN0", 0x10010352, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZD2BN1", 0x10010353, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZD3BN0", 0x10010354, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZD4BN0", 0x10010355, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZE2BN0", 0x10010356, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZE2BN1", 0x10010357, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZE3BN0", 0x10010358, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC103ZE4BN0", 0x10010359, IDD_DIALOG_CONFIGURATION_NUC103},

	/* 105 series*/
	{"NUC105SB2AN0", 0x00010500, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SB2AN1", 0x00010501, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SB3AN0", 0x00010502, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SB4AN0", 0x00010503, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC2AN0", 0x00010504, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC2AN1", 0x00010505, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC3AN0", 0x00010506, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC4AN0", 0x00010507, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC2AN2", 0x00010508, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC2AN3", 0x00010509, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC3AN2", 0x00010510, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC4AN2", 0x00010511, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SD2AN0", 0x00010512, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SD2AN1", 0x00010513, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SD3AN0", 0x00010514, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SD4AN0", 0x00010515, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SE2AN0", 0x00010516, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SE2AN1", 0x00010517, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SE3AN0", 0x00010518, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SE4AN0", 0x00010519, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LB2AN0", 0x00010520, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LB2AN1", 0x00010521, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LB3AN0", 0x00010522, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LB4AN0", 0x00010523, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC2AN0", 0x00010524, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC2AN1", 0x00010525, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC3AN0", 0x00010526, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC4AN0", 0x00010527, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC2AN2", 0x00010528, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC2AN3", 0x00010529, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC3AN2", 0x00010530, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC4AN2", 0x00010531, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LD2AN0", 0x00010532, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LD2AN1", 0x00010533, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LD3AN0", 0x00010534, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LD4AN0", 0x00010535, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LE2AN0", 0x00010536, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LE2AN1", 0x00010537, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LE3AN0", 0x00010538, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LE4AN0", 0x00010539, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZB2AN0", 0x00010540, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZB2AN1", 0x00010541, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZB3AN0", 0x00010542, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZB4AN0", 0x00010543, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC2AN0", 0x00010544, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC2AN1", 0x00010545, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC3AN0", 0x00010546, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC4AN0", 0x00010547, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC2AN2", 0x00010548, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC2AN3", 0x00010549, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC3AN2", 0x00010550, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC4AN2", 0x00010551, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZD2AN0", 0x00010552, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZD2AN1", 0x00010553, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZD3AN0", 0x00010554, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZD4AN0", 0x00010555, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZE2AN0", 0x00010556, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZE2AN1", 0x00010557, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZE3AN0", 0x00010558, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZE4AN0", 0x00010559, IDD_DIALOG_CONFIGURATION_NUC103},

	/* 105 series*/
	{"NUC105SB2BN0", 0x10010500, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SB2BN1", 0x10010501, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SB3BN0", 0x10010502, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SB4BN0", 0x10010503, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC2BN0", 0x10010504, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC2BN1", 0x10010505, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC3BN0", 0x10010506, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC4BN0", 0x10010507, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC2BN2", 0x10010508, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC2BN3", 0x10010509, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC3BN2", 0x10010510, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SC4BN2", 0x10010511, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SD2BN0", 0x10010512, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SD2BN1", 0x10010513, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SD3BN0", 0x10010514, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SD4BN0", 0x10010515, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SE2BN0", 0x10010516, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SE2BN1", 0x10010517, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SE3BN0", 0x10010518, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105SE4BN0", 0x10010519, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LB2BN0", 0x10010520, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LB2BN1", 0x10010521, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LB3BN0", 0x10010522, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LB4BN0", 0x10010523, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC2BN0", 0x10010524, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC2BN1", 0x10010525, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC3BN0", 0x10010526, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC4BN0", 0x10010527, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC2BN2", 0x10010528, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC2BN3", 0x10010529, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC3BN2", 0x10010530, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LC4BN2", 0x10010531, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LD2BN0", 0x10010532, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LD2BN1", 0x10010533, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LD3BN0", 0x10010534, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LD4BN0", 0x10010535, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LE2BN0", 0x10010536, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LE2BN1", 0x10010537, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LE3BN0", 0x10010538, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105LE4BN0", 0x10010539, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZB2BN0", 0x10010540, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZB2BN1", 0x10010541, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZB3BN0", 0x10010542, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZB4BN0", 0x10010543, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC2BN0", 0x10010544, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC2BN1", 0x10010545, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC3BN0", 0x10010546, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC4BN0", 0x10010547, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC2BN2", 0x10010548, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC2BN3", 0x10010549, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC3BN2", 0x10010550, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZC4BN2", 0x10010551, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZD2BN0", 0x10010552, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZD2BN1", 0x10010553, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZD3BN0", 0x10010554, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZD4BN0", 0x10010555, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZE2BN0", 0x10010556, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZE2BN1", 0x10010557, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZE3BN0", 0x10010558, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC105ZE4BN0", 0x10010559, IDD_DIALOG_CONFIGURATION_NUC103},

	{"NUC120LE3AN", 0x00012000, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LE2AN", 0x00012001, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LE1AN", 0x00012002, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LD3AN", 0x00012003, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LD2AN", 0x00012004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LD1AN", 0x00012005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LC3AN", 0x00012006, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LC2AN", 0x00012007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LC1AN", 0x00012008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RE3AN", 0x00012009, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RE2AN", 0x00012010, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RE1AN", 0x00012011, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RD3AN", 0x00012012, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RD2AN", 0x00012013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RD1AN", 0x00012014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RC3AN", 0x00012015, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RC2AN", 0x00012016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RC1AN", 0x00012017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VE3AN", 0x00012018, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VE2AN", 0x00012019, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VE1AN", 0x00012020, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VD3AN", 0x00012021, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VD2AN", 0x00012022, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VD1AN", 0x00012023, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VC3AN", 0x00012024, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VC2AN", 0x00012025, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VC1AN", 0x00012026, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC122LE3AN", 0x00012200, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LE2AN", 0x00012201, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LE1AN", 0x00012202, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LD3AN", 0x00012203, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LD2AN", 0x00012204, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LD1AN", 0x00012205, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LC3AN", 0x00012206, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LC2AN", 0x00012207, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LC1AN", 0x00012208, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RE3AN", 0x00012209, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RE2AN", 0x00012210, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RE1AN", 0x00012211, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RD3AN", 0x00012212, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RD2AN", 0x00012213, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RD1AN", 0x00012214, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RC3AN", 0x00012215, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RC2AN", 0x00012216, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RC1AN", 0x00012217, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SE3AN", 0x00012218, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SE2AN", 0x00012219, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SE1AN", 0x00012220, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SD3AN", 0x00012221, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SD2AN", 0x00012222, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SD1AN", 0x00012223, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SC3AN", 0x00012224, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SC2AN", 0x00012225, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SC1AN", 0x00012226, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZE3AN", 0x00012227, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZE2AN", 0x00012228, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZE1AN", 0x00012229, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZD3AN", 0x00012230, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZD2AN", 0x00012231, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZD1AN", 0x00012232, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZC3AN", 0x00012233, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZC2AN", 0x00012234, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZC1AN", 0x00012235, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZB3AN", 0x00012236, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZB2AN", 0x00012237, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZB1AN", 0x00012238, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZA3AN", 0x00012239, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZA2AN", 0x00012240, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZA1AN", 0x00012241, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LB3AN", 0x00012242, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LB2AN", 0x00012243, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LB1AN", 0x00012244, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LA3AN", 0x00012245, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LA2AN", 0x00012246, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LA1AN", 0x00012247, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RB3AN", 0x00012248, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RB2AN", 0x00012249, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RB1AN", 0x00012250, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RA3AN", 0x00012251, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RA2AN", 0x00012252, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RA1AN", 0x00012253, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SB3AN", 0x00012254, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SB2AN", 0x00012255, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SB1AN", 0x00012256, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SA3AN", 0x00012257, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SA2AN", 0x00012258, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SA1AN", 0x00012259, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LA0AN", 0x00012260, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LB0AN", 0x00012261, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LC0AN", 0x00012262, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122LD0AN", 0x00012263, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RA0AN", 0x00012264, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RB0AN", 0x00012265, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RC0AN", 0x00012266, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122RD0AN", 0x00012267, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SA0AN", 0x00012268, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SB0AN", 0x00012269, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SC0AN", 0x00012270, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122SD0AN", 0x00012271, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZA0AN", 0x00012272, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZB0AN", 0x00012273, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZC0AN", 0x00012274, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122ZD0AN", 0x00012275, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YD3AN", 0x00012276, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YD2AN", 0x00012277, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YD1AN", 0x00012278, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YD0AN", 0x00012279, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YC3AN", 0x00012280, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YC2AN", 0x00012281, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YC1AN", 0x00012282, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YC0AN", 0x00012283, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YB3AN", 0x00012284, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YB2AN", 0x00012285, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YB1AN", 0x00012286, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YB0AN", 0x00012287, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YA3AN", 0x00012288, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YA2AN", 0x00012289, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YA1AN", 0x00012290, IDD_DIALOG_CONFIGURATION_NUC102},
	{"NUC122YA0AN", 0x00012291, IDD_DIALOG_CONFIGURATION_NUC102},

	/* 123 series */
	{"NUC123SB2AN0", 0x00012300, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SB2AN1", 0x00012301, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SB3AN0", 0x00012302, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SB4AN0", 0x00012303, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SC2AN0", 0x00012304, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SC2AN1", 0x00012305, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SC3AN0", 0x00012306, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SC4AN0", 0x00012307, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SC2AN2", 0x00012308, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SC2AN3", 0x00012309, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SC3AN2", 0x00012310, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SC4AN2", 0x00012311, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SD2AN0", 0x00012312, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SD2AN1", 0x00012313, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SD3AN0", 0x00012314, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SD4AN0", 0x00012315, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SE2AN0", 0x00012316, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SE2AN1", 0x00012317, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SE3AN0", 0x00012318, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SE4AN0", 0x00012319, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LB2AN0", 0x00012320, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LB2AN1", 0x00012321, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LB3AN0", 0x00012322, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LB4AN0", 0x00012323, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LC2AN0", 0x00012324, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LC2AN1", 0x00012325, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LC3AN0", 0x00012326, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LC4AN0", 0x00012327, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LC2AN2", 0x00012328, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LC2AN3", 0x00012329, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LC3AN2", 0x00012330, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LC4AN2", 0x00012331, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LD2AN0", 0x00012332, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LD2AN1", 0x00012333, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LD3AN0", 0x00012334, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LD4AN0", 0x00012335, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LE2AN0", 0x00012336, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LE2AN1", 0x00012337, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LE3AN0", 0x00012338, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LE4AN0", 0x00012339, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZB2AN0", 0x00012340, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZB2AN1", 0x00012341, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZB3AN0", 0x00012342, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZB4AN0", 0x00012343, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZC2AN0", 0x00012344, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZC2AN1", 0x00012345, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZC3AN0", 0x00012346, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZC4AN0", 0x00012347, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZC2AN2", 0x00012348, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZC2AN3", 0x00012349, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZC3AN2", 0x00012350, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZC4AN2", 0x00012351, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZD2AN0", 0x00012352, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZD2AN1", 0x00012353, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZD3AN0", 0x00012354, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZD4AN0", 0x00012355, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZE2AN0", 0x00012356, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZE2AN1", 0x00012357, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZE3AN0", 0x00012358, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZE4AN0", 0x00012359, IDD_DIALOG_CONFIGURATION_NUC103},

	/* 123 series */
	{"NUC123SC2AE1", 0x10012305, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SD4AE0", 0x10012315, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LC2AE1", 0x10012325, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123LD4AE0", 0x10012335, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZC2AE1", 0x10012345, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123ZD4AE0", 0x10012355, IDD_DIALOG_CONFIGURATION_NUC103},
	{"NUC123SD4SN0", 0x10012316, IDD_DIALOG_CONFIGURATION_NUC103}, //special part no.
	{"NUC123LC2AP1", 0x10012336, IDD_DIALOG_CONFIGURATION_NUC103}, //special part no.
	{"PH-MN1-33",    0x10012356, IDD_DIALOG_CONFIGURATION_NUC103}, //special part no.

	{"NUC130LE3AN", 0x00013000, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LE2AN", 0x00013001, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LE1AN", 0x00013002, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LD3AN", 0x00013003, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LD2AN", 0x00013004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LD1AN", 0x00013005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LC3AN", 0x00013006, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LC2AN", 0x00013007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LC1AN", 0x00013008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RE3AN", 0x00013009, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RE2AN", 0x00013010, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RE1AN", 0x00013011, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RD3AN", 0x00013012, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RD2AN", 0x00013013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RD1AN", 0x00013014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RC3AN", 0x00013015, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RC2AN", 0x00013016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RC1AN", 0x00013017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VE3AN", 0x00013018, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VE2AN", 0x00013019, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VE1AN", 0x00013020, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VD3AN", 0x00013021, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VD2AN", 0x00013022, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VD1AN", 0x00013023, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VC3AN", 0x00013024, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VC2AN", 0x00013025, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VC1AN", 0x00013026, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC140LE3AN", 0x00014000, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LE2AN", 0x00014001, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LE1AN", 0x00014002, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LD3AN", 0x00014003, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LD2AN", 0x00014004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LD1AN", 0x00014005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LC3AN", 0x00014006, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LC2AN", 0x00014007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LC1AN", 0x00014008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RE3AN", 0x00014009, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RE2AN", 0x00014010, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RE1AN", 0x00014011, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RD3AN", 0x00014012, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RD2AN", 0x00014013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RD1AN", 0x00014014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RC3AN", 0x00014015, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RC2AN", 0x00014016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RC1AN", 0x00014017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VE3AN", 0x00014018, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VE2AN", 0x00014019, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VE1AN", 0x00014020, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VD3AN", 0x00014021, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VD2AN", 0x00014022, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VD1AN", 0x00014023, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VC3AN", 0x00014024, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VC2AN", 0x00014025, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VC1AN", 0x00014026, IDD_DIALOG_CONFIGURATION_NUC100},

	/* NUC1xx series low density */
	{"NUC100LD2BN", 0x10010004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LD1BN", 0x10010005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LD0BN", 0x10010027, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LC2BN", 0x10010007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LC1BN", 0x10010008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LC0BN", 0x10010028, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LB2BN", 0x10010029, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LB1BN", 0x10010030, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LB0BN", 0x10010031, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LA2BN", 0x10010032, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LA1BN", 0x10010033, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LA0BN", 0x10010034, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RD2BN", 0x10010013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RD1BN", 0x10010014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RD0BN", 0x10010035, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RC2BN", 0x10010016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RC1BN", 0x10010017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RC0BN", 0x10010036, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RB2BN", 0x10010037, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RB1BN", 0x10010038, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RB0BN", 0x10010039, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RA2BN", 0x10010040, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RA1BN", 0x10010041, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RA0BN", 0x10010042, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC101LD2BN", 0x10010104, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LD1BN", 0x10010105, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LD0BN", 0x10010127, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LC2BN", 0x10010107, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LC1BN", 0x10010108, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LC0BN", 0x10010128, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LB2BN", 0x10010129, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LB1BN", 0x10010130, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LB0BN", 0x10010131, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LA2BN", 0x10010132, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LA1BN", 0x10010133, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LA0BN", 0x10010134, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RD2BN", 0x10010113, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RD1BN", 0x10010114, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RD0BN", 0x10010135, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RC2BN", 0x10010116, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RC1BN", 0x10010117, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RC0BN", 0x10010136, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RB2BN", 0x10010137, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RB1BN", 0x10010138, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RB0BN", 0x10010139, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RA2BN", 0x10010140, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RA1BN", 0x10010141, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RA0BN", 0x10010142, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YD2BN", 0x10010143, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YD1BN", 0x10010144, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YD0BN", 0x10010145, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YC2BN", 0x10010146, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YC1BN", 0x10010147, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YC0BN", 0x10010148, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YB2BN", 0x10010149, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YB1BN", 0x10010150, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YB0BN", 0x10010151, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YA2BN", 0x10010152, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YA1BN", 0x10010153, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101YA0BN", 0x10010154, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC120LD2BN", 0x10012004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LD1BN", 0x10012005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LD0BN", 0x10012027, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LC2BN", 0x10012007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LC1BN", 0x10012008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LC0BN", 0x10012028, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LB2BN", 0x10012029, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LB1BN", 0x10012030, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LB0BN", 0x10012031, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LA2BN", 0x10012032, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LA1BN", 0x10012033, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LA0BN", 0x10012034, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RD2BN", 0x10012013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RD1BN", 0x10012014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RD0BN", 0x10012035, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RC2BN", 0x10012016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RC1BN", 0x10012017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RC0BN", 0x10012036, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RB2BN", 0x10012037, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RB1BN", 0x10012038, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RB0BN", 0x10012039, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RA2BN", 0x10012040, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RA1BN", 0x10012041, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RA0BN", 0x10012042, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC122SD2BN", 0x10012222, IDD_DIALOG_CONFIGURATION_NUC102},//CY 2012/09/28

	{"NUC130LD2BN", 0x10013004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LD1BN", 0x10013005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LD0BN", 0x10013027, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LC2BN", 0x10013007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LC1BN", 0x10013008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LC0BN", 0x10013028, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LB2BN", 0x10013029, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LB1BN", 0x10013030, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LB0BN", 0x10013031, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LA2BN", 0x10013032, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LA1BN", 0x10013033, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LA0BN", 0x10013034, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RD2BN", 0x10013013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RD1BN", 0x10013014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RD0BN", 0x10013035, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RC2BN", 0x10013016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RC1BN", 0x10013017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RC0BN", 0x10013036, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RB2BN", 0x10013037, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RB1BN", 0x10013038, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RB0BN", 0x10013039, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RA2BN", 0x10013040, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RA1BN", 0x10013041, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RA0BN", 0x10013042, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC140LD2BN", 0x10014004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LD1BN", 0x10014005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LD0BN", 0x10014027, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LC2BN", 0x10014007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LC1BN", 0x10014008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LC0BN", 0x10014028, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LB2BN", 0x10014029, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LB1BN", 0x10014030, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LB0BN", 0x10014031, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LA2BN", 0x10014032, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LA1BN", 0x10014033, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LA0BN", 0x10014034, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RD2BN", 0x10014013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RD1BN", 0x10014014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RD0BN", 0x10014035, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RC2BN", 0x10014016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RC1BN", 0x10014017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RC0BN", 0x10014036, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RB2BN", 0x10014037, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RB1BN", 0x10014038, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RB0BN", 0x10014039, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RA2BN", 0x10014040, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RA1BN", 0x10014041, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RA0BN", 0x10014042, IDD_DIALOG_CONFIGURATION_NUC100},

	/* */
	{"NUC100LE3CN", 0x20010000, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LE2CN", 0x20010001, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LE1CN", 0x20010002, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LD3CN", 0x20010003, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LD2CN", 0x20010004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LD1CN", 0x20010005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LC3CN", 0x20010006, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LC2CN", 0x20010007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100LC1CN", 0x20010008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RE3CN", 0x20010009, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RE2CN", 0x20010010, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RE1CN", 0x20010011, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RD3CN", 0x20010012, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RD2CN", 0x20010013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RD1CN", 0x20010014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RC3CN", 0x20010015, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RC2CN", 0x20010016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100RC1CN", 0x20010017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VE3CN", 0x20010018, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VE2CN", 0x20010019, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VE1CN", 0x20010020, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VD3CN", 0x20010021, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VD2CN", 0x20010022, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VD1CN", 0x20010023, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VC3CN", 0x20010024, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VC2CN", 0x20010025, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC100VC1CN", 0x20010026, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC101LE3CN", 0x20010100, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LE2CN", 0x20010101, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LE1CN", 0x20010102, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LD3CN", 0x20010103, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LD2CN", 0x20010104, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LD1CN", 0x20010105, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LC3CN", 0x20010106, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LC2CN", 0x20010107, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101LC1CN", 0x20010108, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RE3CN", 0x20010109, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RE2CN", 0x20010110, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RE1CN", 0x20010111, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RD3CN", 0x20010112, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RD2CN", 0x20010113, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RD1CN", 0x20010114, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RC3CN", 0x20010115, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RC2CN", 0x20010116, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101RC1CN", 0x20010117, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VE3CN", 0x20010118, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VE2CN", 0x20010119, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VE1CN", 0x20010120, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VD3CN", 0x20010121, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VD2CN", 0x20010122, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VD1CN", 0x20010123, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VC3CN", 0x20010124, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VC2CN", 0x20010125, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC101VC1CN", 0x20010126, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC120LE3CN", 0x20012000, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LE2CN", 0x20012001, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LE1CN", 0x20012002, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LD3CN", 0x20012003, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LD2CN", 0x20012004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LD1CN", 0x20012005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LC3CN", 0x20012006, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LC2CN", 0x20012007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LC1CN", 0x20012008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RE3CN", 0x20012009, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RE2CN", 0x20012010, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RE1CN", 0x20012011, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RD3CN", 0x20012012, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RD2CN", 0x20012013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RD1CN", 0x20012014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RC3CN", 0x20012015, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RC2CN", 0x20012016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120RC1CN", 0x20012017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VE3CN", 0x20012018, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VE2CN", 0x20012019, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VE1CN", 0x20012020, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VD3CN", 0x20012021, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VD2CN", 0x20012022, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VD1CN", 0x20012023, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VC3CN", 0x20012024, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VC2CN", 0x20012025, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120VC1CN", 0x20012026, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC130LE3CN", 0x20013000, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LE2CN", 0x20013001, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LE1CN", 0x20013002, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LD3CN", 0x20013003, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LD2CN", 0x20013004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LD1CN", 0x20013005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LC3CN", 0x20013006, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LC2CN", 0x20013007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LC1CN", 0x20013008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RE3CN", 0x20013009, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RE2CN", 0x20013010, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RE1CN", 0x20013011, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RD3CN", 0x20013012, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RD2CN", 0x20013013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RD1CN", 0x20013014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RC3CN", 0x20013015, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RC2CN", 0x20013016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130RC1CN", 0x20013017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VE3CN", 0x20013018, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VE2CN", 0x20013019, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VE1CN", 0x20013020, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VD3CN", 0x20013021, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VD2CN", 0x20013022, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VD1CN", 0x20013023, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VC3CN", 0x20013024, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VC2CN", 0x20013025, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130VC1CN", 0x20013026, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC140LE3CN", 0x20014000, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LE2CN", 0x20014001, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LE1CN", 0x20014002, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LD3CN", 0x20014003, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LD2CN", 0x20014004, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LD1CN", 0x20014005, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LC3CN", 0x20014006, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LC2CN", 0x20014007, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140LC1CN", 0x20014008, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RE3CN", 0x20014009, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RE2CN", 0x20014010, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RE1CN", 0x20014011, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RD3CN", 0x20014012, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RD2CN", 0x20014013, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RD1CN", 0x20014014, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RC3CN", 0x20014015, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RC2CN", 0x20014016, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140RC1CN", 0x20014017, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VE3CN", 0x20014018, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VE2CN", 0x20014019, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VE1CN", 0x20014020, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VD3CN", 0x20014021, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VD2CN", 0x20014022, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VD1CN", 0x20014023, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VC3CN", 0x20014024, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VC2CN", 0x20014025, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC140VC1CN", 0x20014026, IDD_DIALOG_CONFIGURATION_NUC100},

	{"NUC100LE3DN", 0x30010000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LE2DN", 0x30010001, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LE1DN", 0x30010002, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LD3DN", 0x30010003, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LD2DN", 0x30010004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LD1DN", 0x30010005, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LC3DN", 0x30010006, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LC2DN", 0x30010007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LC1DN", 0x30010008, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RE3DN", 0x30010009, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RE2DN", 0x30010010, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RE1DN", 0x30010011, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RD3DN", 0x30010012, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RD2DN", 0x30010013, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RD1DN", 0x30010014, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RC3DN", 0x30010015, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RC2DN", 0x30010016, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RC1DN", 0x30010017, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VE3DN", 0x30010018, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VE2DN", 0x30010019, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VE1DN", 0x30010020, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VD3DN", 0x30010021, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VD2DN", 0x30010022, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VD1DN", 0x30010023, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VC3DN", 0x30010024, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VC2DN", 0x30010025, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VC1DN", 0x30010026, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100SE3DN", 0x30010027, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100SE2DN", 0x30010028, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100SE1DN", 0x30010029, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100SD3DN", 0x30010030, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100SD2DN", 0x30010031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100SD1DN", 0x30010032, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100SC3DN", 0x30010033, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100SC2DN", 0x30010034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100SC1DN", 0x30010035, IDD_DIALOG_CONFIGURATION_NUC200},

	{"NUC120LE3DN", 0x30012000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LE2DN", 0x30012001, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LE1DN", 0x30012002, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LD3DN", 0x30012003, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LD2DN", 0x30012004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LD1DN", 0x30012005, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LC3DN", 0x30012006, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LC2DN", 0x30012007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LC1DN", 0x30012008, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RE3DN", 0x30012009, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RE2DN", 0x30012010, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RE1DN", 0x30012011, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RD3DN", 0x30012012, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RD2DN", 0x30012013, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RD1DN", 0x30012014, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RC3DN", 0x30012015, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RC2DN", 0x30012016, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RC1DN", 0x30012017, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VE3DN", 0x30012018, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VE2DN", 0x30012019, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VE1DN", 0x30012020, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VD3DN", 0x30012021, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VD2DN", 0x30012022, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VD1DN", 0x30012023, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VC3DN", 0x30012024, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VC2DN", 0x30012025, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VC1DN", 0x30012026, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RE3DN", 0x30012027, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RE2DN", 0x30012028, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RE1DN", 0x30012029, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RD3DN", 0x30012030, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RD2DN", 0x30012031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RD1DN", 0x30012032, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RC3DN", 0x30012033, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RC2DN", 0x30012034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RC1DN", 0x30012035, IDD_DIALOG_CONFIGURATION_NUC200},

	{"NUC130LE3DN", 0x30013000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130LE2DN", 0x30013001, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130LE1DN", 0x30013002, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130LD3DN", 0x30013003, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130LD2DN", 0x30013004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130LD1DN", 0x30013005, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130LC3DN", 0x30013006, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130LC2DN", 0x30013007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130LC1DN", 0x30013008, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RE3DN", 0x30013009, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RE2DN", 0x30013010, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RE1DN", 0x30013011, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RD3DN", 0x30013012, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RD2DN", 0x30013013, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RD1DN", 0x30013014, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RC3DN", 0x30013015, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RC2DN", 0x30013016, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RC1DN", 0x30013017, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130VE3DN", 0x30013018, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130VE2DN", 0x30013019, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130VE1DN", 0x30013020, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130VD3DN", 0x30013021, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130VD2DN", 0x30013022, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130VD1DN", 0x30013023, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130VC3DN", 0x30013024, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130VC2DN", 0x30013025, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130VC1DN", 0x30013026, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RE3DN", 0x30013027, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RE2DN", 0x30013028, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RE1DN", 0x30013029, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RD3DN", 0x30013030, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RD2DN", 0x30013031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RD1DN", 0x30013032, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RC3DN", 0x30013033, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RC2DN", 0x30013034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC130RC1DN", 0x30013035, IDD_DIALOG_CONFIGURATION_NUC200},

	{"NUC140LE3DN", 0x30014000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140LE2DN", 0x30014001, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140LE1DN", 0x30014002, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140LD3DN", 0x30014003, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140LD2DN", 0x30014004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140LD1DN", 0x30014005, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140LC3DN", 0x30014006, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140LC2DN", 0x30014007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140LC1DN", 0x30014008, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RE3DN", 0x30014009, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RE2DN", 0x30014010, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RE1DN", 0x30014011, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RD3DN", 0x30014012, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RD2DN", 0x30014013, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RD1DN", 0x30014014, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RC3DN", 0x30014015, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RC2DN", 0x30014016, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RC1DN", 0x30014017, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140VE3DN", 0x30014018, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140VE2DN", 0x30014019, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140VE1DN", 0x30014020, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140VD3DN", 0x30014021, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140VD2DN", 0x30014022, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140VD1DN", 0x30014023, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140VC3DN", 0x30014024, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140VC2DN", 0x30014025, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140VC1DN", 0x30014026, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RE3DN", 0x30014027, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RE2DN", 0x30014028, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RE1DN", 0x30014029, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RD3DN", 0x30014030, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RD2DN", 0x30014031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RD1DN", 0x30014032, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RC3DN", 0x30014033, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RC2DN", 0x30014034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC140RC1DN", 0x30014035, IDD_DIALOG_CONFIGURATION_NUC200},

	/* NUC1xxEN */
	{"NUC100LC1EN", 0x40010008, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LD1EN", 0x40010005, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LD2EN", 0x40010004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RC1EN", 0x40010017, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RD1EN", 0x40010014, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RD2EN", 0x40010013, IDD_DIALOG_CONFIGURATION_NUC200},
//	{"NUC100SD2EN", 0x40010013, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LD3EN", 0x40010003, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100LE3EN", 0x40010000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RD3EN", 0x40010012, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100RE3EN", 0x40010009, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VD2EN", 0x40010022, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VD3EN", 0x40010021, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC100VE3DE", 0x40010018, IDD_DIALOG_CONFIGURATION_NUC200},

	{"NUC120LC1EN", 0x40012008, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LD1EN", 0x40012005, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LD2DE", 0x40012004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RC1EN", 0x40012017, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RD1EN", 0x40012014, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RD2EN", 0x40012013, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LD3EN", 0x40012003, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120LE3EN", 0x40012000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RD3EN", 0x40012012, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120RE3EN", 0x40012009, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VD2EN", 0x40012022, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VD3EN", 0x40012021, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC120VE3EN", 0x40012018, IDD_DIALOG_CONFIGURATION_NUC200},

	//{"NUC130RC1EN", 0x40013017, IDD_DIALOG_CONFIGURATION_NUC200},

	/* NUC131AE */
	{"NUC131LD2AE", 0x10013100, IDD_DIALOG_CONFIGURATION_NUC131},
	{"NUC131LC2AE", 0x10013103, IDD_DIALOG_CONFIGURATION_NUC131},
	{"NUC131SD2AE", 0x10013110, IDD_DIALOG_CONFIGURATION_NUC131},
	{"NUC131SC2AE", 0x10013113, IDD_DIALOG_CONFIGURATION_NUC131},
	{"NUC131RD2AE", 0x10013120, IDD_DIALOG_CONFIGURATION_NUC131},
	{"NUC131RC2AE", 0x10013123, IDD_DIALOG_CONFIGURATION_NUC131},
	{"NUC131FAE", 0x100131B0, IDD_DIALOG_CONFIGURATION_NUC131},

	/* M0518AE */
	{"M0518LD2AE", 0x10051800, IDD_DIALOG_CONFIGURATION_NUC131},
	{"M0518LC2AE", 0x10051803, IDD_DIALOG_CONFIGURATION_NUC131},
	{"M0518SD2AE", 0x10051810, IDD_DIALOG_CONFIGURATION_NUC131},
	{"M0518SC2AE", 0x10051813, IDD_DIALOG_CONFIGURATION_NUC131},

	{"NM1320LC2AE", 0x00032003, IDD_DIALOG_CONFIGURATION_NUC131},
	
	/* FB8239 NUC2xxAE */
	{"NUC200LC2AE", 0x10020007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LD2AE", 0x10020004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LE3AE", 0x10020000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SC2AE", 0x10020034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SD2AE", 0x10020031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SE3AE", 0x10020027, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VE3AE", 0x10020018, IDD_DIALOG_CONFIGURATION_NUC200},

	{"NUC220LC2AE", 0x10022007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LD2AE", 0x10022004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LE3AE", 0x40022000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SC2AE", 0x10022034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SD2AE", 0x10022031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SE3AE", 0x10022027, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VE3AE", 0x10022018, IDD_DIALOG_CONFIGURATION_NUC200},

	{"NUC230RC1AE", 0x40013017, IDD_DIALOG_CONFIGURATION_NUC200},  //20131115, this is a special part in NUC200 series, it is confirmed by CHKuo
	{"NUC230LC2AE", 0x10023007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC230LD2AE", 0x10023004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC230LE3AE", 0x10023000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC230SC2AE", 0x10023034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC230SD2AE", 0x10023031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC230SE3AE", 0x10023027, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC230VE3AE", 0x10023018, IDD_DIALOG_CONFIGURATION_NUC200},

	{"NUC240LC2AE", 0x10024007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC240LD2AE", 0x10024004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC240LE3AE", 0x10024000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC240SC2AE", 0x10024034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC240SD2AE", 0x10024031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC240SE3AE", 0x10024027, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC240VE3AE", 0x10024018, IDD_DIALOG_CONFIGURATION_NUC200},

	/* FIX for some wrong NUC1xx */
	{"NUC100VE3AN", 0x00100018, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC120LE3AN", 0x00120000, IDD_DIALOG_CONFIGURATION_NUC100},
	{"NUC130LE3AN", 0x00130000, IDD_DIALOG_CONFIGURATION_NUC100},

	/* Special Nano100 for N512 */
	{"N512DC4", 0x00100000, IDD_DIALOG_CONFIGURATION_NANO100}, 
	{"N512LC4", 0x00100001, IDD_DIALOG_CONFIGURATION_NANO100},
	{"N512", 0x00100002, IDD_DIALOG_CONFIGURATION_NANO100},
	{"N512MC4", 0x00100003, IDD_DIALOG_CONFIGURATION_NANO100},
	{"N512", 0x00100004, IDD_DIALOG_CONFIGURATION_NANO100},
	{"N512SC4", 0x00100005, IDD_DIALOG_CONFIGURATION_NANO100},
	{"N512", 0x00100006, IDD_DIALOG_CONFIGURATION_NANO100},
	{"N512", 0x00100007, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"N512LC4", 0x00100008, IDD_DIALOG_CONFIGURATION_NANO100},	//CY 2012/10/3 Mark
	//{"N512MC4", 0x00100009, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"N512SC4", 0x00100010, IDD_DIALOG_CONFIGURATION_NANO100},

	/* Special Nano100 for N512 */
	{"N512VD4", 0x00100008, IDD_DIALOG_CONFIGURATION_NANO100BN},	//CY 2012/10/3 for HKChang request. FB8240 use new name.
	{"N512MD4", 0x00100009, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"N512SD4", 0x00100010, IDD_DIALOG_CONFIGURATION_NANO100BN},

	/*NUC200xxxAN is useless*/		//CY 2012/11/28 enable 
	{"NUC200LE3AN", 0x00020000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LE2AN", 0x00020001, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LE1AN", 0x00020002, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LD3AN", 0x00020003, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LD2AN", 0x00020004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LD1AN", 0x00020005, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LC3AN", 0x00020006, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LC2AN", 0x00020007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200LC1AN", 0x00020008, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200RE3AN", 0x00020009, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200RE2AN", 0x00020010, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200RE1AN", 0x00020011, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200RD3AN", 0x00020012, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200RD2AN", 0x00020013, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200RD1AN", 0x00020014, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200RC3AN", 0x00020015, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200RC2AN", 0x00020016, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200RC1AN", 0x00020017, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VE3AN", 0x00020018, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VE2AN", 0x00020019, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VE1AN", 0x00020020, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VD3AN", 0x00020021, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VD2AN", 0x00020022, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VD1AN", 0x00020023, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VC3AN", 0x00020024, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VC2AN", 0x00020025, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200VC1AN", 0x00020026, IDD_DIALOG_CONFIGURATION_NUC200},
	//---------------------------
	{"NUC200SE3AN", 0x00020027, IDD_DIALOG_CONFIGURATION_NUC200},		//CY 2012/11/28 add 
	{"NUC200SE2AN", 0x00020028, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SE1AN", 0x00020029, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SD3AN", 0x00020030, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SD2AN", 0x00020031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SD1AN", 0x00020032, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SC3AN", 0x00020033, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SC2AN", 0x00020034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC200SC1AN", 0x00020035, IDD_DIALOG_CONFIGURATION_NUC200},
	//---------------------------
	{"NUC220LE3AN", 0x00022000, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LE2AN", 0x00022001, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LE1AN", 0x00022002, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LD3AN", 0x00022003, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LD2AN", 0x00022004, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LD1AN", 0x00022005, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LC3AN", 0x00022006, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LC2AN", 0x00022007, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220LC1AN", 0x00022008, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220RE3AN", 0x00022009, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220RE2AN", 0x00022010, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220RE1AN", 0x00022011, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220RD3AN", 0x00022012, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220RD2AN", 0x00022013, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220RD1AN", 0x00022014, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220RC3AN", 0x00022015, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220RC2AN", 0x00022016, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220RC1AN", 0x00022017, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VE3AN", 0x00022018, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VE2AN", 0x00022019, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VE1AN", 0x00022020, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VD3AN", 0x00022021, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VD2AN", 0x00022022, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VD1AN", 0x00022023, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VC3AN", 0x00022024, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VC2AN", 0x00022025, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220VC1AN", 0x00022026, IDD_DIALOG_CONFIGURATION_NUC200},
	//---------------------------
	{"NUC220SE3AN", 0x00022027, IDD_DIALOG_CONFIGURATION_NUC200},		//CY 2012/11/28 add 
	{"NUC220SE2AN", 0x00022028, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SE1AN", 0x00022029, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SD3AN", 0x00022030, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SD2AN", 0x00022031, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SD1AN", 0x00022032, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SC3AN", 0x00022033, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SC2AN", 0x00022034, IDD_DIALOG_CONFIGURATION_NUC200},
	{"NUC220SC1AN", 0x00022035, IDD_DIALOG_CONFIGURATION_NUC200},
	//---------------------------
/*-----------------------------------------
	//CY 2012/11/28 disable
	{"NUC200LE3CN", 0x00020000},
	{"NUC200LE2CN", 0x00020001},
	{"NUC200LE1CN", 0x00020002},
	{"NUC200LD3CN", 0x00020003},
	{"NUC200LD2CN", 0x00020004},
	{"NUC200LD1CN", 0x00020005},
	{"NUC200LC3CN", 0x00020006},
	{"NUC200LC2CN", 0x00020007},
	{"NUC200LC1CN", 0x00020008},
	{"NUC200RE3CN", 0x00020009},
	{"NUC200RE2CN", 0x00020010},
	{"NUC200RE1CN", 0x00020011},
	{"NUC200RD3CN", 0x00020012},
	{"NUC200RD2CN", 0x00020013},
	{"NUC200RD1CN", 0x00020014},
	{"NUC200RC3CN", 0x00020015},
	{"NUC200RC2CN", 0x00020016},
	{"NUC200RC1CN", 0x00020017},
	{"NUC200VE3CN", 0x00020018},
	{"NUC200VE2CN", 0x00020019},
	{"NUC200VE1CN", 0x00020020},
	{"NUC200VD3CN", 0x00020021},
	{"NUC200VD2CN", 0x00020022},
	{"NUC200VD1CN", 0x00020023},
	{"NUC200VC3CN", 0x00020024},
	{"NUC200VC2CN", 0x00020025},
	{"NUC200VC1CN", 0x00020026},
	{"NUC200SE3CN", 0x00020027},
	{"NUC200SE2CN", 0x00020028},
	{"NUC200SE1CN", 0x00020029},
	{"NUC200SD3CN", 0x00020030},
	{"NUC200SD2CN", 0x00020031},
	{"NUC200SD1CN", 0x00020032},
	{"NUC200SC3CN", 0x00020033},
	{"NUC200SC2CN", 0x00020034},
	{"NUC200SC1CN", 0x00020035},

	{"NUC220LE3CN", 0x00022000},
	{"NUC220LE2CN", 0x00022001},
	{"NUC220LE1CN", 0x00022002},
	{"NUC220LD3CN", 0x00022003},
	{"NUC220LD2CN", 0x00022004},
	{"NUC220LD1CN", 0x00022005},
	{"NUC220LC3CN", 0x00022006},
	{"NUC220LC2CN", 0x00022007},
	{"NUC220LC1CN", 0x00022008},
	{"NUC220RE3CN", 0x00022009},
	{"NUC220RE2CN", 0x00022010},
	{"NUC220RE1CN", 0x00022011},
	{"NUC220RD3CN", 0x00022012},
	{"NUC220RD2CN", 0x00022013},
	{"NUC220RD1CN", 0x00022014},
	{"NUC220RC3CN", 0x00022015},
	{"NUC220RC2CN", 0x00022016},
	{"NUC220RC1CN", 0x00022017},
	{"NUC220VE3CN", 0x00022018},
	{"NUC220VE2CN", 0x00022019},
	{"NUC220VE1CN", 0x00022020},
	{"NUC220VD3CN", 0x00022021},
	{"NUC220VD2CN", 0x00022022},
	{"NUC220VD1CN", 0x00022023},
	{"NUC220VC3CN", 0x00022024},
	{"NUC220VC2CN", 0x00022025},
	{"NUC220VC1CN", 0x00022026},
	{"NUC220RE3CN", 0x00022027},
	{"NUC220RE2CN", 0x00022028},
	{"NUC220RE1CN", 0x00022029},
	{"NUC220RD3CN", 0x00022030},
	{"NUC220RD2CN", 0x00022031},
	{"NUC220RD1CN", 0x00022032},
	{"NUC220RC3CN", 0x00022033},
	{"NUC220RC2CN", 0x00022034},
	{"NUC220RC1CN", 0x00022035},

	{"NUC230LE3CN", 0x00023000},
	{"NUC230LE2CN", 0x00023001},
	{"NUC230LE1CN", 0x00023002},
	{"NUC230LD3CN", 0x00023003},
	{"NUC230LD2CN", 0x00023004},
	{"NUC230LD1CN", 0x00023005},
	{"NUC230LC3CN", 0x00023006},
	{"NUC230LC2CN", 0x00023007},
	{"NUC230LC1CN", 0x00023008},
	{"NUC230RE3CN", 0x00023009},
	{"NUC230RE2CN", 0x00023010},
	{"NUC230RE1CN", 0x00023011},
	{"NUC230RD3CN", 0x00023012},
	{"NUC230RD2CN", 0x00023013},
	{"NUC230RD1CN", 0x00023014},
	{"NUC230RC3CN", 0x00023015},
	{"NUC230RC2CN", 0x00023016},
	{"NUC230RC1CN", 0x00023017},
	{"NUC230VE3CN", 0x00023018},
	{"NUC230VE2CN", 0x00023019},
	{"NUC230VE1CN", 0x00023020},
	{"NUC230VD3CN", 0x00023021},
	{"NUC230VD2CN", 0x00023022},
	{"NUC230VD1CN", 0x00023023},
	{"NUC230VC3CN", 0x00023024},
	{"NUC230VC2CN", 0x00023025},
	{"NUC230VC1CN", 0x00023026},
	{"NUC230RE3CN", 0x00023027},
	{"NUC230RE2CN", 0x00023028},
	{"NUC230RE1CN", 0x00023029},
	{"NUC230RD3CN", 0x00023030},
	{"NUC230RD2CN", 0x00023031},
	{"NUC230RD1CN", 0x00023032},
	{"NUC230RC3CN", 0x00023033},
	{"NUC230RC2CN", 0x00023034},
	{"NUC230RC1CN", 0x00023035},

	{"NUC240LE3CN", 0x00024000},
	{"NUC240LE2CN", 0x00024001},
	{"NUC240LE1CN", 0x00024002},
	{"NUC240LD3CN", 0x00024003},
	{"NUC240LD2CN", 0x00024004},
	{"NUC240LD1CN", 0x00024005},
	{"NUC240LC3CN", 0x00024006},
	{"NUC240LC2CN", 0x00024007},
	{"NUC240LC1CN", 0x00024008},
	{"NUC240RE3CN", 0x00024009},
	{"NUC240RE2CN", 0x00024010},
	{"NUC240RE1CN", 0x00024011},
	{"NUC240RD3CN", 0x00024012},
	{"NUC240RD2CN", 0x00024013},
	{"NUC240RD1CN", 0x00024014},
	{"NUC240RC3CN", 0x00024015},
	{"NUC240RC2CN", 0x00024016},
	{"NUC240RC1CN", 0x00024017},
	{"NUC240VE3CN", 0x00024018},
	{"NUC240VE2CN", 0x00024019},
	{"NUC240VE1CN", 0x00024020},
	{"NUC240VD3CN", 0x00024021},
	{"NUC240VD2CN", 0x00024022},
	{"NUC240VD1CN", 0x00024023},
	{"NUC240VC3CN", 0x00024024},
	{"NUC240VC2CN", 0x00024025},
	{"NUC240VC1CN", 0x00024026},
	{"NUC240RE3CN", 0x00024027},
	{"NUC240RE2CN", 0x00024028},
	{"NUC240RE1CN", 0x00024029},
	{"NUC240RD3CN", 0x00024030},
	{"NUC240RD2CN", 0x00024031},
	{"NUC240RD1CN", 0x00024032},
	{"NUC240RC3CN", 0x00024033},
	{"NUC240RC2CN", 0x00024034},
	{"NUC240RC1CN", 0x00024035},
	*/

	/* NUC029 */
	{"NUC029LAN", 0x00295A00, IDD_DIALOG_CONFIGURATION_M051CN},
	{"NUC029TAN", 0x00295804, IDD_DIALOG_CONFIGURATION_M051CN},
	{"NUC029CIG1", 0x00295824, IDD_DIALOG_CONFIGURATION_M051CN},
	{"NUC029ZAN", 0x00295A03, IDD_DIALOG_CONFIGURATION_M051CN},
	{"NUC029FAE", 0x00295415, IDD_DIALOG_CONFIGURATION_MINI51CN},

	/* M05x's Part Number */
	{"M051LAN", 0x00005100, IDD_DIALOG_CONFIGURATION_M051},
	{"M051PAN", 0x00005101, IDD_DIALOG_CONFIGURATION_M051},
	{"M051YAN", 0x00005102, IDD_DIALOG_CONFIGURATION_M051},
	{"M051ZAN", 0x00005103, IDD_DIALOG_CONFIGURATION_M051},
	{"M052LAN", 0x00005200, IDD_DIALOG_CONFIGURATION_M051},
	{"M052PAN", 0x00005201, IDD_DIALOG_CONFIGURATION_M051},
	{"M052YAN", 0x00005202, IDD_DIALOG_CONFIGURATION_M051},
	{"M052ZAN", 0x00005203, IDD_DIALOG_CONFIGURATION_M051},
	{"M054LAN", 0x00005400, IDD_DIALOG_CONFIGURATION_M051},
	{"M054PAN", 0x00005401, IDD_DIALOG_CONFIGURATION_M051},
	{"M054YAN", 0x00005402, IDD_DIALOG_CONFIGURATION_M051},
	{"M054ZAN", 0x00005403, IDD_DIALOG_CONFIGURATION_M051},
	{"M058LAN", 0x00005800, IDD_DIALOG_CONFIGURATION_M051},
	{"M058PAN", 0x00005801, IDD_DIALOG_CONFIGURATION_M051},
	{"M058YAN", 0x00005802, IDD_DIALOG_CONFIGURATION_M051},
	{"M058ZAN", 0x00005803, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516LAN", 0x00005A00, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516PAN", 0x00005A01, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516YAN", 0x00005A02, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516ZAN", 0x00005A03, IDD_DIALOG_CONFIGURATION_M051},

	/* */
	{"M054SLAN", 0x00005410, IDD_DIALOG_CONFIGURATION_M058},
	{"M058SLAN", 0x00005810, IDD_DIALOG_CONFIGURATION_M058},
	{"M059SLAN", 0x00005910, IDD_DIALOG_CONFIGURATION_M058},
	{"M054SZAN", 0x00005413, IDD_DIALOG_CONFIGURATION_M058},
	{"M058SZAN", 0x00005813, IDD_DIALOG_CONFIGURATION_M058},
	{"M059SZAN", 0x00005913, IDD_DIALOG_CONFIGURATION_M058},
	{"M054STAN", 0x00005414, IDD_DIALOG_CONFIGURATION_M058},
	{"M058STAN", 0x00005814, IDD_DIALOG_CONFIGURATION_M058},
	{"M059STAN", 0x00005914, IDD_DIALOG_CONFIGURATION_M058},
	{"M054SSAN", 0x00005416, IDD_DIALOG_CONFIGURATION_M058},
	{"M058SSAN", 0x00005816, IDD_DIALOG_CONFIGURATION_M058},
	{"M059SSAN", 0x00005916, IDD_DIALOG_CONFIGURATION_M058},
	{"M058SFAN", 0x00005818, IDD_DIALOG_CONFIGURATION_M058},

	{"M051LBN", 0x10005100, IDD_DIALOG_CONFIGURATION_M051},
	{"M051PBN", 0x10005101, IDD_DIALOG_CONFIGURATION_M051},
	{"M051YBN", 0x10005102, IDD_DIALOG_CONFIGURATION_M051},
	{"M051ZBN", 0x10005103, IDD_DIALOG_CONFIGURATION_M051},
	{"M052LBN", 0x10005200, IDD_DIALOG_CONFIGURATION_M051},
	{"M052PBN", 0x10005201, IDD_DIALOG_CONFIGURATION_M051},
	{"M052YBN", 0x10005202, IDD_DIALOG_CONFIGURATION_M051},
	{"M052ZBN", 0x10005203, IDD_DIALOG_CONFIGURATION_M051},
	{"M052TBN", 0x10005204, IDD_DIALOG_CONFIGURATION_M051},
	{"M052XBN", 0x10005205, IDD_DIALOG_CONFIGURATION_M051},
	{"M054LBN", 0x10005400, IDD_DIALOG_CONFIGURATION_M051},
	{"M054PBN", 0x10005401, IDD_DIALOG_CONFIGURATION_M051},
	{"M054YBN", 0x10005402, IDD_DIALOG_CONFIGURATION_M051},
	{"M054ZBN", 0x10005403, IDD_DIALOG_CONFIGURATION_M051},
	{"M054TBN", 0x10005404, IDD_DIALOG_CONFIGURATION_M051},
	{"M054XBN", 0x10005405, IDD_DIALOG_CONFIGURATION_M051},
	{"M058LBN", 0x10005800, IDD_DIALOG_CONFIGURATION_M051},
	{"M058PBN", 0x10005801, IDD_DIALOG_CONFIGURATION_M051},
	{"M058YBN", 0x10005802, IDD_DIALOG_CONFIGURATION_M051},
	{"M058ZBN", 0x10005803, IDD_DIALOG_CONFIGURATION_M051},
	{"M058TBN", 0x10005804, IDD_DIALOG_CONFIGURATION_M051},
	{"M058XBN", 0x10005805, IDD_DIALOG_CONFIGURATION_M051},
	{"E32", 0x10005406, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516LBN", 0x10005A00, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516PBN", 0x10005A01, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516YBN", 0x10005A02, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516ZBN", 0x10005A03, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516TBN", 0x10005A04, IDD_DIALOG_CONFIGURATION_M051},
	{"M0516XBN", 0x10005A05, IDD_DIALOG_CONFIGURATION_M051},

	/* DN*/
	{"M052LDN", 0x20005200, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M052ZDN", 0x20005203, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M052TDN", 0x20005204, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M052XDN", 0x20005205, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M054LDN", 0x20005400, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M054ZDN", 0x20005403, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M054TDN", 0x20005404, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M054XDN", 0x20005405, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M058LDN", 0x20005800, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M058ZDN", 0x20005803, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M058TDN", 0x20005804, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M058XDN", 0x20005805, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M0516LDN", 0x20005A00, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M0516ZDN", 0x20005A03, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M0516TDN", 0x20005A04, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M0516XDN", 0x20005A05, IDD_DIALOG_CONFIGURATION_M051CN},

	/* DE*/
	{"M052LDE", 0x30005200, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M052ZDE", 0x30005203, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M052TDE", 0x30005204, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M052XDE", 0x30005205, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M054LDE", 0x30005400, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M054ZDE", 0x30005403, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M054TDE", 0x30005404, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M054XDE", 0x30005405, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M058LDE", 0x30005800, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M058ZDE", 0x30005803, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M058TDE", 0x30005804, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M058XDE", 0x30005805, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M0516LDE", 0x30005A00, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M0516ZDE", 0x30005A03, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M0516TDE", 0x30005A04, IDD_DIALOG_CONFIGURATION_M051CN},
	{"M0516XDE", 0x30005A05, IDD_DIALOG_CONFIGURATION_M051CN},

	{"NM1330LC1AE", 0x30005810, IDD_DIALOG_CONFIGURATION_M051CN},
	{"NM1330LD2AE", 0x30005A10, IDD_DIALOG_CONFIGURATION_M051CN},

	//
	{"Nano112LB0AN", 0x00111201, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112LB1AN", 0x00111202, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112LC1AN", 0x00111203, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112LC2AN", 0x00111204, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112SB0AN", 0x00111205, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112SB1AN", 0x00111206, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112SC1AN", 0x00111207, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112SC2AN", 0x00111208, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112RB0AN", 0x00111209, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112RB1AN", 0x00111210, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112RC1AN", 0x00111211, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112RC2AN", 0x00111212, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112VB0AN", 0x00111213, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112VB1AN", 0x00111214, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112VC1AN", 0x00111215, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano112VC2AN", 0x00111216, IDD_DIALOG_CONFIGURATION_NANO112},

	{"Nano102ZB0AN", 0x00110201, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102ZB1AN", 0x00110202, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102ZC1AN", 0x00110203, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102ZC2AN", 0x00110204, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102LB0AN", 0x00110205, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102LB1AN", 0x00110206, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102LC1AN", 0x00110207, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102LC2AN", 0x00110208, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102SB0AN", 0x00110209, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102SB1AN", 0x00110210, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102SC1AN", 0x00110211, IDD_DIALOG_CONFIGURATION_NANO112},
	{"Nano102SC2AN", 0x00110212, IDD_DIALOG_CONFIGURATION_NANO112},

	//
	{"Nano103SD3AE",0x00110301, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103SD2AE",0x00110302, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103SD1AE",0x00110303, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103LD3AE",0x00110304, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103LD2AE",0x00110305, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103LD1AE",0x00110306, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103ZD3AE",0x00110307, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103ZD2AE",0x00110308, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103ZD1AE",0x00110309, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103SC3AE",0x00110316, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103SC2AE",0x00110310, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103SC1AE",0x00110311, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103LC3AE",0x00110317, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103LC2AE",0x00110312, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103LC1AE",0x00110313, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103ZC3AE",0x00110318, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103ZC2AE",0x00110314, IDD_DIALOG_CONFIGURATION_NANO103},
	{"Nano103ZC1AE",0x00110315, IDD_DIALOG_CONFIGURATION_NANO103},
	{"YM0232A03S",0x00110320, IDD_DIALOG_CONFIGURATION_NANO103},

	{"Nano100VF3AN", 0x00110000, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100VF2AN", 0x00110001, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100SF3AN", 0x00110002, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100SF2AN", 0x00110003, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100LF3AN", 0x00110004, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100LF2AN", 0x00110005, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100VE3AN", 0x00110006, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100VE2AN", 0x00110007, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100SE3AN", 0x00110008, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100SE2AN", 0x00110009, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100LE3AN", 0x00110010, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100LE2AN", 0x00110011, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100VD3AN", 0x00110012, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100VD2AN", 0x00110013, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100VD1AN", 0x00110014, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100SD3AN", 0x00110015, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100SD2AN", 0x00110016, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100SD1AN", 0x00110017, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100LD3AN", 0x00110018, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100LD2AN", 0x00110019, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100LD1AN", 0x00110020, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100VC2AN", 0x00110021, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100VC1AN", 0x00110022, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100SC2AN", 0x00110023, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100SC1AN", 0x00110024, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100LC2AN", 0x00110025, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100LC1AN", 0x00110026, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100ZD3AN", 0x00110027, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100ZD2AN", 0x00110028, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano100ZC2AN", 0x00110029, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano100TD3AN", 0x00110030, IDD_DIALOG_CONFIGURATION_NANO100},

	{"Nano110VF3AN", 0x00111000, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110VF2AN", 0x00111001, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110SF3AN", 0x00111002, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110SF2AN", 0x00111003, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano110LF3AN", 0x00111004, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano110LF2AN", 0x00111005, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110VE3AN", 0x00111006, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110VE2AN", 0x00111007, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110SE3AN", 0x00111008, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110SE2AN", 0x00111009, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano110LE3AN", 0x00111010, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano110LE2AN", 0x00111011, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110VD3AN", 0x00111012, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110VD2AN", 0x00111013, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110VD1AN", 0x00111014, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110SD3AN", 0x00111015, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110SD2AN", 0x00111016, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110SD1AN", 0x00111017, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano110LD3AN", 0x00111018, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano110LD2AN", 0x00111019, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano110LD1AN", 0x00111020, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110VC2AN", 0x00111021, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110VC1AN", 0x00111022, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110SC2AN", 0x00111023, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano110SC1AN", 0x00111024, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano110LC2AN", 0x00111025, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano110LC1AN", 0x00111026, IDD_DIALOG_CONFIGURATION_NANO100},

	{"Nano120VF3AN", 0x00112000, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120VF2AN", 0x00112001, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120SF3AN", 0x00112002, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120SF2AN", 0x00112003, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120LF3AN", 0x00112004, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120LF2AN", 0x00112005, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120VE3AN", 0x00112006, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120VE2AN", 0x00112007, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120SE3AN", 0x00112008, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120SE2AN", 0x00112009, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120LE3AN", 0x00112010, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120LE2AN", 0x00112011, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120VD3AN", 0x00112012, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120VD2AN", 0x00112013, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120VD1AN", 0x00112014, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120SD3AN", 0x00112015, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120SD2AN", 0x00112016, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120SD1AN", 0x00112017, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120LD3AN", 0x00112018, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120LD2AN", 0x00112019, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120LD1AN", 0x00112020, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120VC2AN", 0x00112021, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120VC1AN", 0x00112022, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120SC2AN", 0x00112023, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120SC1AN", 0x00112024, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120LC2AN", 0x00112025, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120LC1AN", 0x00112026, IDD_DIALOG_CONFIGURATION_NANO100},
	
	{"Nano120ZD3AN", 0x00112027, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120ZD2AN", 0x00112028, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano120ZC2AN", 0x00112029, IDD_DIALOG_CONFIGURATION_NANO100},

	{"Nano130VF3AN", 0x00113000, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130VF2AN", 0x00113001, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130SF3AN", 0x00113002, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130SF2AN", 0x00113003, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano130LF3AN", 0x00113004, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano130LF2AN", 0x00113005, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130VE3AN", 0x00113006, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130VE2AN", 0x00113007, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130SE3AN", 0x00113008, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130SE2AN", 0x00113009, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano130LE3AN", 0x00113010, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano130LE2AN", 0x00113011, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130VD3AN", 0x00113012, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130VD2AN", 0x00113013, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130VD1AN", 0x00113014, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130SD3AN", 0x00113015, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130SD2AN", 0x00113016, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130SD1AN", 0x00113017, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano130LD3AN", 0x00113018, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano130LD2AN", 0x00113019, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano130LD1AN", 0x00113020, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130VC2AN", 0x00113021, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130VC1AN", 0x00113022, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130SC2AN", 0x00113023, IDD_DIALOG_CONFIGURATION_NANO100},
	{"Nano130SC1AN", 0x00113024, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano130LC2AN", 0x00113025, IDD_DIALOG_CONFIGURATION_NANO100},
	//{"Nano130LC1AN", 0x00113026, IDD_DIALOG_CONFIGURATION_NANO100},
	
	//
	{"Nano100KE3BN", 0x00110030, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100KE2BN", 0x00110031, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100VE3BN", 0x00110032, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100VE2BN", 0x00110033, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100SE3BN", 0x00110034, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100SE2BN", 0x00110035, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100LE3BN", 0x00110036, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100LE2BN", 0x00110037, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100KD3BN", 0x00110038, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100KD2BN", 0x00110039, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100VD3BN", 0x0011003A, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100VD2BN", 0x0011003B, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100SD3BN", 0x0011003C, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100SD2BN", 0x0011003D, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100LD3BN", 0x0011003E, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100LD2BN", 0x0011003F, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100KC2BN", 0x00110040, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100VC2BN", 0x00110041, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100SC2BN", 0x00110042, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano100LC2BN", 0x00110043, IDD_DIALOG_CONFIGURATION_NANO100BN},

	{"Nano110KE3BN", 0x00111030, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110KE2BN", 0x00111031, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110VE3BN", 0x00111032, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110VE2BN", 0x00111033, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110SE3BN", 0x00111034, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110SE2BN", 0x00111035, IDD_DIALOG_CONFIGURATION_NANO100BN},
	//{"Nano110LE3BN", 0x00111036, IDD_DIALOG_CONFIGURATION_NANO100BN},
	//{"Nano110LE2BN", 0x00111037, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110KD3BN", 0x00111038, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110KD2BN", 0x00111039, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110VD3BN", 0x0011103A, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110VD2BN", 0x0011103B, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110SD3BN", 0x0011103C, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110SD2BN", 0x0011103D, IDD_DIALOG_CONFIGURATION_NANO100BN},
	//{"Nano110LD3BN", 0x0011103E, IDD_DIALOG_CONFIGURATION_NANO100BN},
	//{"Nano110LD2BN", 0x0011103F, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110KC2BN", 0x00111040, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110VC2BN", 0x00111041, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110SC2BN", 0x00111042, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110RC2BN", 0x00111043, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110RD2BN", 0x00111044, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano110RD3BN", 0x00111045, IDD_DIALOG_CONFIGURATION_NANO100BN},

	{"Nano120KE3BN", 0x00112030, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120KE2BN", 0x00112031, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120VE3BN", 0x00112032, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120VE2BN", 0x00112033, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120SE3BN", 0x00112034, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120SE2BN", 0x00112035, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120LE3BN", 0x00112036, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120LE2BN", 0x00112037, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120KD3BN", 0x00112038, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120KD2BN", 0x00112039, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120VD3BN", 0x0011203A, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120VD2BN", 0x0011203B, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120SD3BN", 0x0011203C, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120SD2BN", 0x0011203D, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120LD3BN", 0x0011203E, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120LD2BN", 0x0011203F, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120KC2BN", 0x00112040, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120VC2BN", 0x00112041, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120SC2BN", 0x00112042, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano120LC2BN", 0x00112043, IDD_DIALOG_CONFIGURATION_NANO100BN},

	{"Nano130KE3BN", 0x00113030, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130KE2BN", 0x00113031, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130VE3BN", 0x00113032, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130VE2BN", 0x00113033, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130SE3BN", 0x00113034, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130SE2BN", 0x00113035, IDD_DIALOG_CONFIGURATION_NANO100BN},
	//{"Nano130LE3BN", 0x00113036, IDD_DIALOG_CONFIGURATION_NANO100BN},
	//{"Nano130LE2BN", 0x00113037, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130KD3BN", 0x00113038, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130KD2BN", 0x00113039, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130VD3BN", 0x0011303A, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130VD2BN", 0x0011303B, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130SD3BN", 0x0011303C, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130SD2BN", 0x0011303D, IDD_DIALOG_CONFIGURATION_NANO100BN},
	//{"Nano130LD3BN", 0x0011303E, IDD_DIALOG_CONFIGURATION_NANO100BN},
	//{"Nano130LD2BN", 0x0011303F, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130KC2BN", 0x00113040, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130VC2BN", 0x00113041, IDD_DIALOG_CONFIGURATION_NANO100BN},
	{"Nano130SC2BN", 0x00113042, IDD_DIALOG_CONFIGURATION_NANO100BN},
	//{"Nano130LC2BN", 0x00113043, IDD_DIALOG_CONFIGURATION_NANO100BN},

	//
	{"MINI51LAN", 0x00205100, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI51QAN", 0x00205101, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI51", 0x00205102, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI51ZAN", 0x00205103, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI51TAN", 0x00205104, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI52LAN", 0x00205200, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI52QAN", 0x00205201, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI52", 0x00205202, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI52ZAN", 0x00205203, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI52TAN", 0x00205204, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI54LAN", 0x00205400, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI54QAN", 0x00205401, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI54", 0x00205402, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI54ZAN", 0x00205403, IDD_DIALOG_CONFIGURATION_MINI51},
	{"MINI54TAN", 0x00205404, IDD_DIALOG_CONFIGURATION_MINI51},    //CY 2012/10/11

	//						//CY 2013/12/04
	/*
	*/
	//{"MINI51LBN", 0x10205100, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI51QBN", 0x10205101, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI51", 0x10205102, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI51ZBN", 0x10205103, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI51TBN", 0x10205104, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI52LBN", 0x10205200, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI52QBN", 0x10205201, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI52", 0x10205202, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI52ZBN", 0x10205203, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI52TBN", 0x10205204, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI54LBN", 0x10205400, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI54QBN", 0x10205401, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI54", 0x10205402, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI54ZBN", 0x10205403, IDD_DIALOG_CONFIGURATION_MINI51BN},
	//{"MINI54TBN", 0x10205404, IDD_DIALOG_CONFIGURATION_MINI51BN},

	/* MINI51DE */
	{"MINI51LDE", 0x20205100, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI51QDE", 0x20205101, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI51", 0x20205102, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI51ZDE", 0x20205103, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI51TDE", 0x20205104, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI51FDE", 0x20205105, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI52LDE", 0x20205200, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI52QDE", 0x20205201, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI52", 0x20205202, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI52ZDE", 0x20205203, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI52TDE", 0x20205204, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI52FDE", 0x20205205, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI54LDE", 0x20205400, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI54QDE", 0x20205401, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI54", 0x20205402, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI54ZDE", 0x20205403, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI54TDE", 0x20205404, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI54FDE", 0x20205405, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI54FHC", 0x20205406, IDD_DIALOG_CONFIGURATION_MINI51CN},

	/* MINI51X NM1200 */
	{"MINI51XLAE", 0x00505100, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI51XTAE", 0x00505101, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI51XZAE", 0x00505102, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI51XFAE", 0x00505104, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI52XLAE", 0x00505200, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI52XZAE", 0x00505203, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI52XTAE", 0x00505204, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI52XFAE", 0x00505205, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI54XLAE", 0x00505400, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI54XZAE", 0x00505403, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI54XTAE", 0x00505404, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI54XFAE", 0x00505405, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI54XFHC", 0x00505406, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI55LDE",  0x00505500, IDD_DIALOG_CONFIGURATION_NM1200},
	{"MINI55ZDE",  0x00505503, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NVS06AL",    0x00505600, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1200LAAE", 0x00605200, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1200TAAE", 0x00605204, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1100XAAE", 0x00605207, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1100FAAE", 0x00605208, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1200LBAE", 0x00605400, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1200ZBAE", 0x00605403, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1200TBAE", 0x00605404, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1100XBAE", 0x00605407, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1100FBAE", 0x00605408, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1100DBAE", 0x0060540A, IDD_DIALOG_CONFIGURATION_NM1200},
	{"T32S200",    0x00605411, IDD_DIALOG_CONFIGURATION_NM1200}, //special part no.

	/* NM1820 */
	{"NM1821FB0AE",	0x00682100, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1820EB0AE", 0x00682010, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1820ZB0AE",	0x00682020, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1820LB0AE",	0x00682030, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1824FB0AE",	0x00682410, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1823EB0AE",	0x00682320, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1823ZB0AE",	0x00682330, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1823LB0AE",	0x00682340, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1827UB0AE",	0x00682710, IDD_DIALOG_CONFIGURATION_NM1200},
	{"NM1827YB0AE", 0x00682720, IDD_DIALOG_CONFIGURATION_NM1200},

	/* Mini58 */
	{"MINI58LDE", 0x00A05800, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI58QDE", 0x00A05801, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI58ZDE", 0x00A05803, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI58TDE", 0x00A05804, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI58FDE", 0x00A05805, IDD_DIALOG_CONFIGURATION_MINI51CN},
	{"MINI58FHC", 0x00A05806, IDD_DIALOG_CONFIGURATION_MINI51CN},

	/* NM1120 Temp PID */
	{"NM1120DC1AE", 0x00B01400, IDD_DIALOG_CONFIGURATION_NM1120}, //GAG014
	{"NM1120FC1AE", 0x00B01420, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120EC1AE", 0x00B01440, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120XC1AE", 0x00B01450, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120TC1AE", 0x00B01460, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120ZC1AE", 0x00B01470, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120DB0AE", 0x00B01300, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120FB0AE", 0x00B01320, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120EB0AE", 0x00B01340, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120XB0AE", 0x00B01350, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120TB0AE", 0x00B01360, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1120ZB0AE", 0x00B01370, IDD_DIALOG_CONFIGURATION_NM1120},

	/* NM1810 */
	{"NM1810FC1AE", 0x00B81000, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1812FC1AE", 0x00B81200, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1810EC1AE", 0x00B81010, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1811EC1AE", 0x00B81110, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1810ZC1AE", 0x00B81020, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1811ZC1AE", 0x00B81020, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1810XC1AE", 0x00B81030, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1811XC1AE", 0x00B81130, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1810LC1AE", 0x00B81040, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1813FC1AE", 0x00B81310, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1813EC1AE", 0x00B81320, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1813ZC1AE", 0x00B81330, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1813LC1AE", 0x00B81340, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1817UC1AE", 0x00B81710, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM1817YC1AE", 0x00B81720, IDD_DIALOG_CONFIGURATION_NM1120},

	/* MT5xx */
	{"NM1510LB1AE", 0x00351008, IDD_DIALOG_CONFIGURATION_MT500},
	{"NM1510LC1AE", 0x00351006, IDD_DIALOG_CONFIGURATION_MT500},
	{"NM1520LC2AE", 0x00352005, IDD_DIALOG_CONFIGURATION_MT500},
	{"NM1520LD2AE", 0x00352003, IDD_DIALOG_CONFIGURATION_MT500},
	{"NM1520RC2AE", 0x00352025, IDD_DIALOG_CONFIGURATION_MT500},
	{"NM1520RD2AE", 0x00352023, IDD_DIALOG_CONFIGURATION_MT500},
	{"NM1530VD3AE", 0x00353032, IDD_DIALOG_CONFIGURATION_MT500},
	{"NM1530VE3AE", 0x00353030, IDD_DIALOG_CONFIGURATION_MT500},

	//M0519 series
	{"M0519VE3AE", 0x00051930, IDD_DIALOG_CONFIGURATION_MT500},
	{"M0519SE3AE", 0x00051920, IDD_DIALOG_CONFIGURATION_MT500},
	{"M0519SD3AE", 0x00051922, IDD_DIALOG_CONFIGURATION_MT500},
	{"M0519LE3AE", 0x00051900, IDD_DIALOG_CONFIGURATION_MT500},
	{"M0519LD3AE", 0x00051902, IDD_DIALOG_CONFIGURATION_MT500},
	//MT5xx series
	//{"MT510LB1BE", 0x10351008, IDD_DIALOG_CONFIGURATION_MT500},
	//{"MT510LC1BE", 0x10351006, IDD_DIALOG_CONFIGURATION_MT500},
	//{"MT520LC2BE", 0x10352005, IDD_DIALOG_CONFIGURATION_MT500},
	//{"MT520LD2BE", 0x10352003, IDD_DIALOG_CONFIGURATION_MT500},
	//{"MT520RC2BE", 0x10352025, IDD_DIALOG_CONFIGURATION_MT500},
	//{"MT520RD2BE", 0x10352023, IDD_DIALOG_CONFIGURATION_MT500},
	//{"MT530VD3BE", 0x10353032, IDD_DIALOG_CONFIGURATION_MT500},
	//{"MT530VE3BE", 0x10353030, IDD_DIALOG_CONFIGURATION_MT500},

	/* ISD9000 */
	{"ISD9032F", 0x1d010362, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9032C", 0x1d030362, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9032T", 0x1d040362, IDD_DIALOG_CONFIGURATION_AU9100},

	{"ISD9160", 0x1d000000, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9160", 0x1d000182, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9160", 0x1d000183, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9160", 0x1d000181, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d000173, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d000172, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d000171, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d000163, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d000162, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d000161, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d000153, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d000152, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d000151, IDD_DIALOG_CONFIGURATION_AU9100},

	{"ISD9160", 0x1d010182, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9160", 0x1d010183, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9160", 0x1d010181, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d010173, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d010172, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d010171, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d010163, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d010162, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d010161, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d010153, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d010152, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d010151, IDD_DIALOG_CONFIGURATION_AU9100},

	{"ISD9160", 0x1d020182, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9160", 0x1d020183, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9160", 0x1d020181, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d020173, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d020172, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d020171, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d020163, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d020162, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d020161, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d020153, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d020152, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d020151, IDD_DIALOG_CONFIGURATION_AU9100},

	{"ISD9160", 0x1d030182, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9160", 0x1d030183, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9160", 0x1d030181, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d030173, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d030172, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9140", 0x1d030171, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d030163, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d030162, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9130", 0x1d030161, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d030153, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d030152, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9120", 0x1d030151, IDD_DIALOG_CONFIGURATION_AU9100},

	{"ISD9340", 0x1d000273, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9341", 0x1d000274, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9360", 0x1d000283, IDD_DIALOG_CONFIGURATION_AU9100},
	{"ISD9361", 0x1d000284, IDD_DIALOG_CONFIGURATION_AU9100},

	{"AU9110", 0x1d0f0182, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0183, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0181, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0173, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0172, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0171, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0163, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0162, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0161, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0153, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0152, IDD_DIALOG_CONFIGURATION_AU9100},
	{"AU9110", 0x1d0f0151, IDD_DIALOG_CONFIGURATION_AU9100},

	/* N572 */
	{"N572F065", 0x0b650000, IDD_DIALOG_CONFIGURATION_N572},
	{"N572F065", 0xe5720000, IDD_DIALOG_CONFIGURATION_N572},
	{"N572F065", 0xf0640000, IDD_DIALOG_CONFIGURATION_N572},
	{"N572F072", 0x0b720000, IDD_DIALOG_CONFIGURATION_N572},
	{"N572C072", 0x0b200000, IDD_DIALOG_CONFIGURATION_N572},

	/* N570 */
	{"N570F064", 0x0b020000, IDD_DIALOG_CONFIGURATION_AU9100},
	{"N570C064", 0x0b030000, IDD_DIALOG_CONFIGURATION_AU9100},
	{"N570F064", 0x0b020362, IDD_DIALOG_CONFIGURATION_AU9100},
	{"N570C064", 0x0b030362, IDD_DIALOG_CONFIGURATION_AU9100},

	/* N575 */
	{"N575F145", 0x0b510000, IDD_DIALOG_CONFIGURATION_AU9100},
	{"N575C145", 0x0b520000, IDD_DIALOG_CONFIGURATION_AU9100},

	/* N576 */
	{"N576F145", 0x0b600000, IDD_DIALOG_CONFIGURATION_AU9100},
	{"N576C145", 0x0b610000, IDD_DIALOG_CONFIGURATION_AU9100},

	/* NUC4xx series*/
	{"NUC472HI8AE", 0x00047201, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472HH8AE", 0x00047202, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472HG8AE", 0x00047203, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472JI8AE", 0x00047204, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472JH8AE", 0x00047205, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472JG8AE", 0x00047206, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472KI8AE", 0x00047207, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472KH8AE", 0x00047208, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472KG8AE", 0x00047209, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472VI8AE", 0x00047210, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472VH8AE", 0x00047211, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC472VG8AE", 0x00047212, IDD_DIALOG_CONFIGURATION_NUC400},

	{"NUC460JI8AE", 0x00046001, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460JH8AE", 0x00046002, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460JG8AE", 0x00046003, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460KI8AE", 0x00046004, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460KH8AE", 0x00046005, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460KG8AE", 0x00046006, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460VI8AE", 0x00046007, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460VH8AE", 0x00046008, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460VG8AE", 0x00046009, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460RI8AE", 0x00046010, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460RH8AE", 0x00046011, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC460RG8AE", 0x00046012, IDD_DIALOG_CONFIGURATION_NUC400},

	{"NUC452JI8AE", 0x00045201, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC452JH8AE", 0x00045202, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC452JG8AE", 0x00045203, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC452KI8AE", 0x00045204, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC452KH8AE", 0x00045205, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC452KG8AE", 0x00045206, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC452VI8AE", 0x00045207, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC452VH8AE", 0x00045208, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC452VG8AE", 0x00045209, IDD_DIALOG_CONFIGURATION_NUC400},

	{"NUC442JI8AE", 0x00044201, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442JH8AE", 0x00044202, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442JG8AE", 0x00044203, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442KI8AE", 0x00044204, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442KH8AE", 0x00044205, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442KG8AE", 0x00044206, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442VI8AE", 0x00044207, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442VH8AE", 0x00044208, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442VG8AE", 0x00044209, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442RI8AE", 0x00044210, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442RH8AE", 0x00044211, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC442RG8AE", 0x00044212, IDD_DIALOG_CONFIGURATION_NUC400},

	{"NUC430JI8AE", 0x00043001, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430JH8AE", 0x00043002, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430JG8AE", 0x00043003, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430KI8AE", 0x00043004, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430KH8AE", 0x00043005, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430KG8AE", 0x00043006, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430VI8AE", 0x00043007, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430VH8AE", 0x00043008, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430VG8AE", 0x00043009, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430RI8AE", 0x00043010, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430RH8AE", 0x00043011, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC430RG8AE", 0x00043012, IDD_DIALOG_CONFIGURATION_NUC400},

	{"NUC422JI8AE", 0x00042201, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422JH8AE", 0x00042202, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422JG8AE", 0x00042203, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422KI8AE", 0x00042204, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422KH8AE", 0x00042205, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422KG8AE", 0x00042206, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422VI8AE", 0x00042207, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422VH8AE", 0x00042208, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422VG8AE", 0x00042209, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422RI8AE", 0x00042210, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422RH8AE", 0x00042211, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC422RG8AE", 0x00042212, IDD_DIALOG_CONFIGURATION_NUC400},

	{"NUC410JI8AE", 0x00041001, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410JH8AE", 0x00041002, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410JG8AE", 0x00041003, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410KI8AE", 0x00041004, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410KH8AE", 0x00041005, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410KG8AE", 0x00041006, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410VI8AE", 0x00041007, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410VH8AE", 0x00041008, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410VG8AE", 0x00041009, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410RI8AE", 0x00041010, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410RH8AE", 0x00041011, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC410RG8AE", 0x00041012, IDD_DIALOG_CONFIGURATION_NUC400},

	{"NUC400JI8AE", 0x00040001, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400JH8AE", 0x00040002, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400JG8AE", 0x00040003, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400KI8AE", 0x00040004, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400KH8AE", 0x00040005, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400KG8AE", 0x00040006, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400VI8AE", 0x00040007, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400VH8AE", 0x00040008, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400VG8AE", 0x00040009, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400RI8AE", 0x00040010, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400RH8AE", 0x00040011, IDD_DIALOG_CONFIGURATION_NUC400},
	{"NUC400RG8AE", 0x00040012, IDD_DIALOG_CONFIGURATION_NUC400},

	/* M451 series */
	{"M451VG6AE", 0x00845130, IDD_DIALOG_CONFIGURATION_M451},
	{"M451VE6AE", 0x00845131, IDD_DIALOG_CONFIGURATION_M451},
	{"M451RG6AE", 0x00845120, IDD_DIALOG_CONFIGURATION_M451},
	{"M451RE6AE", 0x00845121, IDD_DIALOG_CONFIGURATION_M451},
	{"M451LG6AE", 0x00845100, IDD_DIALOG_CONFIGURATION_M451},
	{"M451LE6AE", 0x00845101, IDD_DIALOG_CONFIGURATION_M451},

	{"M452VG6AE", 0x00845230, IDD_DIALOG_CONFIGURATION_M451},
	{"M452VE6AE", 0x00845231, IDD_DIALOG_CONFIGURATION_M451},
	{"M452RG6AE", 0x00845220, IDD_DIALOG_CONFIGURATION_M451},
	{"M452RE6AE", 0x00845221, IDD_DIALOG_CONFIGURATION_M451},
	{"M452LG6AE", 0x00845200, IDD_DIALOG_CONFIGURATION_M451},
	{"M452LE6AE", 0x00845201, IDD_DIALOG_CONFIGURATION_M451},
	{"M4LEDRG6AE", 0x00845720, IDD_DIALOG_CONFIGURATION_M451},
	{"M4LEDRE6AE", 0x00845721, IDD_DIALOG_CONFIGURATION_M451},
	{"M4LEDLG6AE", 0x00845700, IDD_DIALOG_CONFIGURATION_M451},
	{"M4LEDLE6AE", 0x00845701, IDD_DIALOG_CONFIGURATION_M451},

	{"M453VG6AE", 0x00845330, IDD_DIALOG_CONFIGURATION_M451},
	{"M453VE6AE", 0x00845331, IDD_DIALOG_CONFIGURATION_M451},
	{"M453RG6AE", 0x00845320, IDD_DIALOG_CONFIGURATION_M451},
	{"M453RE6AE", 0x00845321, IDD_DIALOG_CONFIGURATION_M451},
	{"M453LG6AE", 0x00845300, IDD_DIALOG_CONFIGURATION_M451},
	{"M453LE6AE", 0x00845301, IDD_DIALOG_CONFIGURATION_M451},

	{"M4TKVG6AE", 0x00845430, IDD_DIALOG_CONFIGURATION_M451},
	{"M4TKVE6AE", 0x00845431, IDD_DIALOG_CONFIGURATION_M451},
	{"M4TKRG6AE", 0x00845420, IDD_DIALOG_CONFIGURATION_M451},
	{"M4TKRE6AE", 0x00845421, IDD_DIALOG_CONFIGURATION_M451},
	{"M4TKLG6AE", 0x00845400, IDD_DIALOG_CONFIGURATION_M451},
	{"M4TKLE6AE", 0x00845401, IDD_DIALOG_CONFIGURATION_M451},

	{"M451MRG6AE", 0x00845020, IDD_DIALOG_CONFIGURATION_M451},
	{"M451MRE6AE", 0x00845021, IDD_DIALOG_CONFIGURATION_M451},
	{"M451MLG6AE", 0x00845000, IDD_DIALOG_CONFIGURATION_M451},
	{"M451MLE6AE", 0x00845001, IDD_DIALOG_CONFIGURATION_M451},

	{"M451VD3AE", 0x00945130, IDD_DIALOG_CONFIGURATION_M451},
	{"M451VC3AE", 0x00945131, IDD_DIALOG_CONFIGURATION_M451},
	{"M451RD3AE", 0x00945120, IDD_DIALOG_CONFIGURATION_M451},
	{"M451RC3AE", 0x00945121, IDD_DIALOG_CONFIGURATION_M451},
	{"M451SD3AE", 0x00945110, IDD_DIALOG_CONFIGURATION_M451},
	{"M451SC3AE", 0x00945111, IDD_DIALOG_CONFIGURATION_M451},
	{"M451LD3AE", 0x00945100, IDD_DIALOG_CONFIGURATION_M451},
	{"M451LC3AE", 0x00945101, IDD_DIALOG_CONFIGURATION_M451},
	{"M451YD3AE", 0x009451F0, IDD_DIALOG_CONFIGURATION_M451},
	{"M451YC3AE", 0x009451F1, IDD_DIALOG_CONFIGURATION_M451},

	{"M452VD3AE", 0x00945230, IDD_DIALOG_CONFIGURATION_M451},
	{"M452VC3AE", 0x00945231, IDD_DIALOG_CONFIGURATION_M451},
	{"M452RD3AE", 0x00945220, IDD_DIALOG_CONFIGURATION_M451},
	{"M452RC3AE", 0x00945221, IDD_DIALOG_CONFIGURATION_M451},
	{"M452SD3AE", 0x00945210, IDD_DIALOG_CONFIGURATION_M451},
	{"M452SC3AE", 0x00945211, IDD_DIALOG_CONFIGURATION_M451},
	{"M452LD3AE", 0x00945200, IDD_DIALOG_CONFIGURATION_M451},
	{"M452LC3AE", 0x00945201, IDD_DIALOG_CONFIGURATION_M451},
	{"M452YD3AE", 0x009452F0, IDD_DIALOG_CONFIGURATION_M451},
	{"M452YC3AE", 0x009452F1, IDD_DIALOG_CONFIGURATION_M451},

	{"M453VD3AE", 0x00945330, IDD_DIALOG_CONFIGURATION_M451},
	{"M453VC3AE", 0x00945331, IDD_DIALOG_CONFIGURATION_M451},
	{"M453RD3AE", 0x00945320, IDD_DIALOG_CONFIGURATION_M451},
	{"M453RC3AE", 0x00945321, IDD_DIALOG_CONFIGURATION_M451},
	{"M453SD3AE", 0x00945310, IDD_DIALOG_CONFIGURATION_M451},
	{"M453SC3AE", 0x00945311, IDD_DIALOG_CONFIGURATION_M451},
	{"M453LD3AE", 0x00945300, IDD_DIALOG_CONFIGURATION_M451},
	{"M453LC3AE", 0x00945301, IDD_DIALOG_CONFIGURATION_M451},
	{"M453YD3AE", 0x009453F0, IDD_DIALOG_CONFIGURATION_M451},
	{"M453YC3AE", 0x009453F1, IDD_DIALOG_CONFIGURATION_M451},

	{"M451MRD3AE", 0x00945020, IDD_DIALOG_CONFIGURATION_M451},
	{"M451MRC3AE", 0x00945021, IDD_DIALOG_CONFIGURATION_M451},
	{"M451MSD3AE", 0x00945010, IDD_DIALOG_CONFIGURATION_M451},
	{"M451MSC3AE", 0x00945011, IDD_DIALOG_CONFIGURATION_M451},
	{"M451MLD3AE", 0x00945000, IDD_DIALOG_CONFIGURATION_M451},
	{"M451MLC3AE", 0x00945001, IDD_DIALOG_CONFIGURATION_M451},

	/* NUC505 series */
	{"NUC505", 0x00000505, 0x505},

	/* 8051 1T Series */
	{"N76E885", 0x00002150, IDD_DIALOG_CONFIGURATION_N76E1T},
	{"N76E884", 0x00002140, IDD_DIALOG_CONFIGURATION_N76E1T},
	{"N76E616", 0x00002F50, IDD_DIALOG_CONFIGURATION_N76E1T},
	{"N76E003", 0x00003650, IDD_DIALOG_CONFIGURATION_N76E1T},
	{"N76E002", 0x00003640, IDD_DIALOG_CONFIGURATION_N76E1T}
};

bool QueryDataBase(unsigned int uID)
{
    psChipData = NULL;

    for(int i = 0; i < _countof(g_PartNumIDs); ++i) {
        //temporary solution for ISD9300
        if((uID & 0xFF00FF00) == 0x1d000200) {
            if(g_PartNumIDs[i].uID == (uID & 0xFF00FFFF)) {
                psChipData = &(g_PartNumIDs[i]);
                return true;
            }
        }
        //N570
        else if((uID & 0xFFF00000) == 0x0b000000) {
            if(g_PartNumIDs[i].uID == (uID & 0xFFFF0000)) {
                psChipData = &(g_PartNumIDs[i]);
                return true;
            }
        }
        //N575
        else if((uID & 0xFFF00000) == 0x0b500000) {
            if(g_PartNumIDs[i].uID == (uID & 0xFFFF0000)) {
                psChipData = &(g_PartNumIDs[i]);
                return true;
            }
        }
        //N576
        else if((uID & 0xFFF00000) == 0x0b600000) {
            if(g_PartNumIDs[i].uID == (uID & 0xFFFF0000)) {
                psChipData = &(g_PartNumIDs[i]);
                return true;
            }
        } else if(g_PartNumIDs[i].uID == uID) {
            psChipData = &(g_PartNumIDs[i]);
            return true;
        }
    }

	return false;
}

std::string GetPartNumber(unsigned int uID)
{
	if(QueryDataBase(uID))
		return psChipData->szPartNumber;
	else
		return "UnKnown";
}

bool UpdateSizeInfo(unsigned int uID, unsigned int uConfig0, unsigned int uConfig1,
                unsigned int *puNVM_Addr,
                unsigned int *puAPROM_Size, unsigned int *puNVM_Size)
{
    unsigned int uAPROM_Addr;
    unsigned int uLDROM_Addr;
    unsigned int auSPROM_Addr[3];
    unsigned int uKPROM_Addr;
    unsigned int uLDROM_Size;
    unsigned int auSPROM_Size[3];
    unsigned int uKPROM_Size;

    if(GetInfo(uID, uConfig0, uConfig1, &uLDROM_Addr, &uAPROM_Addr,
               puNVM_Addr,
               auSPROM_Addr, &uKPROM_Addr,
               &uLDROM_Size,
               puAPROM_Size, puNVM_Size,
               auSPROM_Size, &uKPROM_Size))
        return true;
    else return GetInfo_N76E1T(uID, uConfig0, uConfig1, &uLDROM_Addr, &uAPROM_Addr,
                                   puNVM_Addr,
                                   &uLDROM_Size,
                                   puAPROM_Size, puNVM_Size);
}